bento.define("game/components/movable",["bento","bento/math/vector2","bento/math/rectangle","bento/entity","bento/eventsystem","bento/utils"],function(t,i,o,e,h,s){"use strict";var n=function(t){this.name="movable",this._col=0,this._row=0,this._height=0,this._nextCol=0,this._nextRow=0,this._nextHeight=0,this._oldCol=0,this._oldRow=0,this._oldHeight=0,this._minTimeBetweenMoves=s.defaultVal(t.minTimeBetweenMoves,2),this._isMoving=!1,this._lastMoveTime=0,this._modifiers=[],this._entity=null};return n.prototype._onMoveComplete=function(){var t=this._col,i=this._row,o=this._height;this._col=this._nextCol,this._row=this._nextRow,this._height=this._nextHeight,this._lastMoveTime=this._entity.timer,this._entity.mapPosition.set(this._col,this._row,this._height),this._isMoving=!1,this._entity.dispatcher.fire("postMove",{oldCol:t,oldRow:i,oldHeight:o,newCol:this._col,newRow:this._row,newHeight:this._height})},n.prototype.setAnimator=function(t){this._animator=t,this._animator.setEntity(this._entity),this._animator.setCompleteCallback(this._onMoveComplete,this)},n.prototype.addModifier=function(t){-1===this._modifiers.indexOf(t)?this._modifiers.push(t):console.warn("already added modifier")},n.prototype.removeModifier=function(t){var i=this._modifiers.indexOf(t);-1!==i?this._modifiers.splice(i,1):console.warn("haven't added modifier")},n.prototype.getModifiers=function(t){return s.Array.clone(this._modifiers)},n.prototype.findCurrentPosition=function(){this._col=this._entity.mapPosition.col,this._row=this._entity.mapPosition.row,this._height=this._entity.mapPosition.height},n.prototype.moveTo=function(t,i,o,e){if(this._animator){if(e||this.canMove){this.findCurrentPosition();var h={from:{col:this._col,row:this._row,height:this._height},to:{col:void 0===t?this._col:t,row:void 0===i?this._row:i,height:void 0===o?this._height:o}};for(let t=0;t<this._modifiers.length;t++){if(this._modifiers[t](h))return}this._nextCol=h.to.col,this._nextRow=h.to.row,this._nextHeight=h.to.height,this._oldCol=this._col,this._oldRow=this._row,this._oldHeight=this._height,this._isMoving=!0,this._animator.play(this._col,this._row,this._height,this._nextCol,this._nextRow,this._nextHeight),this._entity.dispatcher.fire("preMove",{oldCol:this._col,oldRow:this._row,oldHeight:this._height,newCol:this._nextCol,newRow:this._nextRow,newHeight:this._nextHeight})}}else console.warn("movable has no animator")},n.prototype.moveBy=function(t,i,o,e){this.findCurrentPosition(),this.moveTo(this._col+(t||0),this._row+(i||0),this._height+(o||0),e)},n.prototype.attached=function(t){this._entity=t.entity;try{this._col=this._entity.mapPosition.col,this._row=this._entity.mapPosition.row,this._height=this._entity.mapPosition.height,this._nextCol=this._col,this._nextRow=this._row,this._nextHeight=this._height}catch(t){throw"movable needs a mapPosition component!"}this._lastMoveTime=this._entity.timer-this._minTimeBetweenMoves,this._entity[this.name]=this},n.prototype.removed=function(){this._entity[this.name]=this,this._entity=void 0},Object.defineProperties(n.prototype,{isMoving:{get:function(){return this._isMoving}},canMove:{get:function(){return!this._isMoving&&this._entity.timer-this._lastMoveTime>=this._minTimeBetweenMoves}},movement:{get:function(){return{from:{col:this._oldCol,row:this._oldRow,height:this._oldHeight},to:{col:this._nextCol,row:this._nextRow,height:this._nextHeight},diff:{col:this._nextCol-this._oldCol,row:this._nextRow-this._oldRow,height:this._nextHeight-this._oldHeight}}}},animator:{get:function(){return this._animator}}}),n});