bento.define("game/entities/player",["bento","bento/eventsystem","bento/utils","globals","events","bento/components/eventlistener","game/effects/animation","bento/components/sprite","bento/math/vector2","modules/playerdata","game/animators/jump","game/components/alarm","game/effects/speechbubble","bento/tween","game/components/tileimpacter","game/components/shield","game/components/actorsprite","managers/skins"],function(e,t,n,o,a,i,r,l,c,s,m,f,p,u,v,d,g,h){"use strict";const y={idle:{speed:.18,frames:[0,1,2,3,4,5,2,6],loop:!0,hasBackFacing:!0},jump:{speed:.24,frames:[10,11,12,13],loop:!1,hasBackFacing:!0},land:{speed:.24,frames:[10,8,9,8,7],loop:!1,hasBackFacing:!0},angry:{speed:.24,frames:[14,15],loop:!0,hasBackFacing:!1}};return function(l){var w,b=l.actor,E=l.map,A=!1,P=!1,C=[],T="player/sfx_qbert_jump",S="default",L={x:1,y:1},N=new i({eventName:a.Elevator.START,onEvent:function(e){A=!0,b.collider.setActive(!1)}}),_=new i({eventName:a.Elevator.DROP_PLAYER,onEvent:function(e){A=!1,b.collider.setActive(!0)}}),x=function(t,n){if(-1!==E.getHeightAt(t,n))return E.getHeightAt(t,n);var o=e.objects.getByFamily("elevator"),a=e.objects.getByFamily("exit");let i=[].concat(o).concat(a);for(let e=0;e<i.length;e++){if(!i[e].isUsable())continue;let o=i[e].mapPosition;if(o.x===t&&o.y===n)return o.z}return-999},F=function(e){S=e;let t=null!=(w&&w.parent),n=w?w.rootIndex:-1,o=h.getData(e),{frameWidth:a,frameHeight:i,origin:r}=h.getFrameInfo(o);t&&b.remove(w),w=new g({imageName:"players/"+e,origin:r,frameWidth:a,frameHeight:i,backFacingOffset:16,animations:y}),t&&(b.attach(w),b.moveComponentTo(w,n)),T=h.getSpecials(e,"jump")[0]||"player/sfx_qbert_jump"};F(s.load("SELECTED_SKIN")),w.faceFront(),w.setAnimation("idle");var I=function(e,t){b.scale.x=L.x||1,1===L.y?w.faceFront():w.faceBack(),w.setAnimation(e,t)},j=new m({map:E,gravity:.035});j.on("begin",function(t){I("jump"),0===t.diff.col&&0===t.diff.row?e.audio.playSound("sfx_wrong"):e.audio.playSound(T);var n=Math.floor(t.duration);b.attach(new f({name:"landAlarm",duration:n-4,onComplete:function(){I("land",function(){I("idle")})}}))}),j.on("finish",function(n){if(t.fire("taptics",o.Taptics.LIGHT),!P){l.map.getTile(n.to.col,n.to.row)&&(3===C.length&&C.shift(),C.push({col:n.to.col,row:n.to.row}))}e.objects.attach(new r({effect:"land_effect",position:b.position.clone()}))});var k=new i({name:"levelCompleteListener",eventName:a.Level.COMPLETE,ignorePause:!1,onEvent:function(e){var t=E.getTile(b.mapPosition.x,b.mapPosition.y);P=!1;var n=function(){new u({from:0,to:1,in:16,delay:24,ease:"easeInOutQuad",onStart:function(){w.faceFront(),w.setAnimation("jump")},onUpdate:function(e,t){var n=e*(1-e)*4;b.transform.y=-24*n},onComplete:function(){w.faceFront(),w.setAnimation("land",function(){w.setAnimation("idle")}),t||(t=E.getTile(b.mapPosition.x,b.mapPosition.y)),t&&t.top.playImpact(),n()}})};n()}}),D=new i({name:"playerDeathListener",eventName:a.Player.DEATH,ignorePause:!1,onEvent:function(t){P=!0,e.audio.playSound("player/sfx_qbert_hit");var o=new p({offset:new c(8,-36),player:b});"invisible"===h.getSpecials(S,"curse")[0]&&(o.visible=!1);var a=b.getComponent("landAlarm");a?a.onComplete=function(){I("land",function(){P?w.setAnimation("angry"):I("idle")})}:w.setAnimation("angry"),n.timeout(45,function(){if(P){var t="player/sfx_qbert_speech_"+n.random.pick(["01","02"]);e.audio.playSound(t),e.objects.attach(o)}})}}),M=new i({eventName:a.Player.DESPAWN,onEvent:function(e){n.removeFamily("speech")}}),B=new i({eventName:a.Level.REVIVE,onEvent:function(e){P=!1}}),H=new i({eventName:a.Player.RESPAWN,onEvent:function(e){w.setAnimation("idle");var t=n.currentLevel.getStartPosition();for(let e=C.length-1;e>=0;e--){let n=C[e];if(l.map.getTile(n.col,n.row).getComponent("safety").isSafe()){t=n;break}}var o=x(t.col,t.row);b.mapPosition.set(t.col,t.row,o)}}),K=new i({eventName:a.Player.SKIN_CHANGE,ignorePause:!0,onEvent:function(e){b.remove(w),F(e.key),b.attach(w),b.moveComponentTo(w,0),I("idle")}});b.name="player",b.addToFamily("player"),b.attach(w),b.attach(k),b.attach(D),b.attach(M),b.attach(H),b.attach(B),b.attach(N),b.attach(_),b.attach(K),b.movable.setAnimator(j),b.attach(new v),b.transform.y=-4,b.attach(new i({eventName:a.Shields.ACTIVATED,onEvent:function(e){b.attach(new d({isValidEnemyCollision:O}))}})),b.attach(new i({eventName:a.Shields.DEACTIVATED,onEvent:function(e){b.getComponent("shield",function(e){b.remove(e)})}}));b.dispatcher.on("postMove",function(e){e.player=b,t.fire(a.Player.POST_MOVE,e)});var O=function(e){var t=b.movable.movement.diff,n=e.movable.movement.diff,o=b.movable.isMoving&&e.movable.isMoving;if(e.getComponent("freeze")&&(o=!1),o){var a=n.col+t.col,i=n.row+t.row;if(Math.abs(a)+Math.abs(i)!==0)return!1}return!0};b.collider.addTag(o.CollisionTags.PLAYER),b.collider.onCollision(o.CollisionTags.ENEMY,function(e){var n=e.entity;O(n)&&t.fire(a.Player.KILL,{enemy:n})}),b.collider.onCollision(o.CollisionTags.KILLABLE,function(n){var o=n.entity;o.dispatcher.fire("killed"),e.objects.remove(o),o.getComponent("enemy",function(e){e.showDisappearEffect(),t.fire(a.Enemy.KILLED,{enemy:o,cause:"player"})})}),b.collider.onCollision(o.CollisionTags.PICK_UP,function(e){e.entity.getComponent("pickUp",function(e){e.pickUp()})});var R=function(e,t){t<0||e>0?L.x=1:(t>0||e<0)&&(L.x=-1),t>0||e>0?L.y=1:(t<0||e<0)&&(L.y=-1)};return b.movable.addModifier(function(t){if(A)return!0;R(t.to.col-t.from.col,t.to.row-t.from.row);var n=x(t.to.col,t.to.row);if(-999===n||n-t.from.height>1)return t.to.col=t.from.col,t.to.row=t.from.row,t.to.height=t.from.height,void e.objects.attach(new r({position:b.position.add(new c(0,-16)),effect:"effect_wrong"}));t.to.height=n}),C.push({col:b.mapPosition.col,row:b.mapPosition.row}),n.append(b,{isAlive:function(){return!P},isDead:function(){return P},setMoveDirection:R,getMoveHeightAt:x}),b}});